Index: code/branches/input/src/orxonox/CMakeLists.txt
===================================================================
--- code/branches/input/src/orxonox/CMakeLists.txt	(revision 969)
+++ code/branches/input/src/orxonox/CMakeLists.txt	(revision 971)
@@ -1,6 +1,4 @@
 SET( ORXONOX_SRC_FILES
   GraphicsEngine.cc
-  InputEventListener.cc
-  InputHandler.cc
   Main.cc
   Orxonox.cc
Index: code/branches/input/src/orxonox/InputEvent.h
===================================================================
--- code/branches/input/src/orxonox/InputEvent.h	(revision 969)
+++ 	(revision )
@@ -1,52 +1,0 @@
-/*
- *   ORXONOX - the hottest 3D action shooter ever to exist
- *
- *
- *   License notice:
- *
- *   This program is free software; you can redistribute it and/or
- *   modify it under the terms of the GNU General Public License
- *   as published by the Free Software Foundation; either version 2
- *   of the License, or (at your option) any later version.
- *
- *   This program is distributed in the hope that it will be useful,
- *   but WITHOUT ANY WARRANTY; without even the implied warranty of
- *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *   GNU General Public License for more details.
- *
- *   You should have received a copy of the GNU General Public License
- *   along with this program; if not, write to the Free Software
- *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
- *
- *   Author:
- *      Reto Grieder
- *   Co-authors:
- *      ...
- *
- */
-
-/**
- @file
- @brief InputEvent Structure declaration
- */
-
-#ifndef _InputEvent_H__
-#define _InputEvent_H__
-
-#include "OrxonoxPrereqs.h"
-
-namespace orxonox
-{
-  /**
-    @brief Interface that any class can use to get key independent input.
-  */
-  struct InputEvent
-  {
-    unsigned char id;      //!< Event ID
-    bool bStarted;         //!< Tells whether the Event started or ended (e.g. firing started)
-    int data1, data2;      //!< Two additional integer datafields, for instance for the mouse moved event
-    void* dataRef;         //!< Additional pointer to any further data
-  };
-}
-
-#endif /* _InputEvent_H__ */
Index: code/branches/input/src/orxonox/InputEventListener.cc
===================================================================
--- code/branches/input/src/orxonox/InputEventListener.cc	(revision 969)
+++ 	(revision )
@@ -1,53 +1,0 @@
-/*
- *   ORXONOX - the hottest 3D action shooter ever to exist
- *
- *
- *   License notice:
- *
- *   This program is free software; you can redistribute it and/or
- *   modify it under the terms of the GNU General Public License
- *   as published by the Free Software Foundation; either version 2
- *   of the License, or (at your option) any later version.
- *
- *   This program is distributed in the hope that it will be useful,
- *   but WITHOUT ANY WARRANTY; without even the implied warranty of
- *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *   GNU General Public License for more details.
- *
- *   You should have received a copy of the GNU General Public License
- *   along with this program; if not, write to the Free Software
- *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
- *
- *   Author:
- *      Reto Grieder
- *   Co-authors:
- *      Some guy writing the example code from Ogre
- *
- */
-
-/**
- @file
- @brief Core relevant parts of InputEventListener
- */
-
-#include "OrxonoxStableHeaders.h"
-
-#include "core/CoreIncludes.h"
-#include "InputEventListener.h"
-
-namespace orxonox
-{
-  /**
-    @brief standard constructor
-  */
-  InputEventListener::InputEventListener()
-  {
-    RegisterRootObject(InputEventListener);
-    this->bActive_ = true;
-  }
-
-  InputEventListener::~InputEventListener()
-  {
-  }
-
-}
Index: code/branches/input/src/orxonox/InputEventListener.h
===================================================================
--- code/branches/input/src/orxonox/InputEventListener.h	(revision 969)
+++ 	(revision )
@@ -1,60 +1,0 @@
-/*
- *   ORXONOX - the hottest 3D action shooter ever to exist
- *
- *
- *   License notice:
- *
- *   This program is free software; you can redistribute it and/or
- *   modify it under the terms of the GNU General Public License
- *   as published by the Free Software Foundation; either version 2
- *   of the License, or (at your option) any later version.
- *
- *   This program is distributed in the hope that it will be useful,
- *   but WITHOUT ANY WARRANTY; without even the implied warranty of
- *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *   GNU General Public License for more details.
- *
- *   You should have received a copy of the GNU General Public License
- *   along with this program; if not, write to the Free Software
- *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
- *
- *   Author:
- *      Reto Grieder
- *   Co-authors:
- *      ...
- *
- */
-
-/**
- @file
- @brief InputEventListener Interface declaration
- */
-
-#ifndef _InputEventListener_H__
-#define _InputEventListener_H__
-
-#include "OrxonoxPrereqs.h"
-
-#include "core/OrxonoxClass.h"
-#include "InputEvent.h"
-
-namespace orxonox
-{
-  /**
-    @brief Interface that any class can use to get key independent input.
-  */
-  class _OrxonoxExport InputEventListener : virtual public OrxonoxClass
-  {
-    friend class InputHandler;
-  public:
-    InputEventListener();
-    virtual ~InputEventListener();
-    /** Method is called every time an Input event occurs && bActive */
-    virtual void eventOccured(InputEvent &evt) = 0;
-
-  private:
-    bool bActive_;
-  };
-}
-
-#endif /* _InputEventListener_H__ */
Index: code/branches/input/src/orxonox/InputHandler.cc
===================================================================
--- code/branches/input/src/orxonox/InputHandler.cc	(revision 969)
+++ 	(revision )
@@ -1,268 +1,0 @@
-/*
- *   ORXONOX - the hottest 3D action shooter ever to exist
- *
- *
- *   License notice:
- *
- *   This program is free software; you can redistribute it and/or
- *   modify it under the terms of the GNU General Public License
- *   as published by the Free Software Foundation; either version 2
- *   of the License, or (at your option) any later version.
- *
- *   This program is distributed in the hope that it will be useful,
- *   but WITHOUT ANY WARRANTY; without even the implied warranty of
- *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *   GNU General Public License for more details.
- *
- *   You should have received a copy of the GNU General Public License
- *   along with this program; if not, write to the Free Software
- *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
- *
- *   Author:
- *      Reto Grieder
- *   Co-authors:
- *      ...
- *
- */
-
-/**
- @file
- @brief Implementation of a little Input handler that distributes everything
-        coming from OIS.
- */
-
-#include "OrxonoxStableHeaders.h"
-
-#include "core/CoreIncludes.h"
-#include "core/Debug.h"
-#include "Orxonox.h"
-#include "InputEventListener.h"
-#include "InputHandler.h"
-
-namespace orxonox
-{
-  /**
-    @brief The reference to the singleton
-  */
-  InputHandler* InputHandler::singletonRef_s = 0;
-
-  /**
-    @brief Constructor only resets the pointer values to 0.
-  */
-  InputHandler::InputHandler() :
-      mouse_(0), keyboard_(0), inputSystem_(0)
-  {
-    //RegisterObject(InputHandler);
-  }
-
-  /**
-    @brief Destructor only called at the end of the program
-  */
-  InputHandler::~InputHandler()
-  {
-  }
-
-  /**
-    @brief The one instance of the InputHandler is stored in this function.
-    @return The pointer to the only instance of the InputHandler
-  */
-  InputHandler *InputHandler::getSingleton()
-  {
-    if (!singletonRef_s)
-      singletonRef_s = new InputHandler();
-    return singletonRef_s;
-    //static InputHandler theOnlyInstance;
-    //return &theOnlyInstance;
-  }
-
-  /**
-    @brief Creates the OIS::InputMananger, the keyboard and the mouse and
-           assigns the key bindings.
-    @param windowHnd The window handle of the render window
-    @param windowWidth The width of the render window
-    @param windowHeight The height of the render window
-  */
-  bool InputHandler::initialise(size_t windowHnd, int windowWidth, int windowHeight)
-  {
-    if (!this->inputSystem_)
-    {
-      // Setup basic variables
-      OIS::ParamList paramList;
-      std::ostringstream windowHndStr;
-
-      // Fill parameter list
-      windowHndStr << (unsigned int)windowHnd;
-      paramList.insert(std::make_pair(std::string("WINDOW"), windowHndStr.str()));
-
-#if defined OIS_LINUX_PLATFORM
-      paramList.insert(std::make_pair(std::string("XAutoRepeatOn"), std::string("true")));
-#endif
-
-      try
-      {
-        // Create inputsystem
-        inputSystem_ = OIS::InputManager::createInputSystem(paramList);
-        //if (getSoftDebugLevel() >= ORX_DEBUG)
-        //  orxonox::OutputHandler::getOutStream().setOutputLevel(4) << "asdfblah" << std::endl;
-        COUT(ORX_DEBUG) << "*** InputHandler: Created OIS input system" << std::endl;
-
-        // create a keyboard. If none are available the exception is caught.
-        keyboard_ = static_cast<OIS::Keyboard*>(inputSystem_->createInputObject(OIS::OISKeyboard, true));
-        keyboard_->setEventCallback(this);
-        COUT(ORX_DEBUG) << "*** InputHandler: Created OIS mouse" << std::endl;
-
-        // create a mouse. If none are available the exception is caught.
-        mouse_ = static_cast<OIS::Mouse*>(inputSystem_->createInputObject(OIS::OISMouse, true));
-        mouse_->setEventCallback(this);
-        COUT(ORX_DEBUG) << "*** InputHandler: Created OIS keyboard" << std::endl;
-
-        // Set mouse region
-        this->setWindowExtents(windowWidth, windowHeight);
-      }
-      catch (OIS::Exception ex)
-      {
-        // something went wrong with the initialisation
-        COUT(ORX_ERROR) << "Error: Failed creating an input system/keyboard/mouse. Message: \"" << ex.eText << "\"" << std::endl;
-        this->inputSystem_ = 0;
-        return false;
-      }
-    }
-
-    COUT(ORX_DEBUG) << "*** InputHandler: Loading key bindings..." << std::endl;
-    // temporary solution: create event list
-    //InputEvent[] list = this->createEventList();
-    // load the key bindings
-    InputEvent empty = {0, false, 0, 0, 0};
-    for (int i = 0; i < this->numberOfKeys_; i++)
-      this->bindingsKeyPressed_[i] = empty;
-
-    //assign 'abort' to the escape key
-    this->bindingsKeyPressed_[(int)OIS::KC_ESCAPE].id = 1;
-    COUT(ORX_DEBUG) << "*** InputHandler: Loading done." << std::endl;
-
-    return true;
-  }
-
-  /**
-    @brief Destroys all the created input devices.
-  */
-  void InputHandler::destroyDevices()
-  {
-    COUT(ORX_DEBUG) << "*** InputHandler: Destroying InputHandler..." << std::endl;
-    if (this->mouse_)
-      this->inputSystem_->destroyInputObject(mouse_);
-    if (this->keyboard_)
-      this->inputSystem_->destroyInputObject(keyboard_);
-    if (this->inputSystem_)
-      OIS::InputManager::destroyInputSystem(this->inputSystem_);
-
-    this->mouse_         = 0;
-    this->keyboard_      = 0;
-    this->inputSystem_   = 0;
-    COUT(ORX_DEBUG) << "*** InputHandler: Destroying done." << std::endl;
-  }
-
-  /**
-    @brief Destroys the singleton.
-  */
-  void InputHandler::destroySingleton()
-  {
-    if (singletonRef_s)
-      delete singletonRef_s;
-    singletonRef_s = 0;
-  }
-
-  /**
-    @brief Updates the InputHandler
-    @param dt Delta time
-  */
-  void InputHandler::tick(float dt)
-  {
-    //this->mouse_->setEventCallback(this);
-    // capture all the input. That calls the event handlers.
-    if (mouse_)
-      mouse_->capture();
-
-    if (keyboard_)
-      keyboard_->capture();
-  }
-
-  /**
-    @brief Adjusts the mouse window metrics.
-    This method has to be called every time the size of the window changes.
-    @param width The new width of the render window
-    @param height the new height of the render window
-  */
-  void InputHandler::setWindowExtents(int width, int height)
-  {
-    // Set mouse region (if window resizes, we should alter this to reflect as well)
-    const OIS::MouseState &mouseState = mouse_->getMouseState();
-    mouseState.width  = width;
-    mouseState.height = height;
-  }
-
-  /**
-    @brief Calls all the objects from classes that derive from InputEventListener.
-    @param evt The input event that occured.
-  */
-  inline void InputHandler::callListeners(orxonox::InputEvent &evt)
-  {
-    for (Iterator<InputEventListener> it = ObjectList<InputEventListener>::start(); it; )
-    {
-      if (it->bActive_)
-        (it++)->eventOccured(evt);
-      else
-        it++;
-    }
-  }
-
-  /**
-    @brief Event handler for the keyPressed Event.
-    @param e Event information
-  */
-  bool InputHandler::keyPressed(const OIS::KeyEvent &e)
-  {
-    callListeners(this->bindingsKeyPressed_[(int)e.key]);
-    return true;
-  }
-
-  /**
-    @brief Event handler for the keyReleased Event.
-    @param e Event information
-  */
-  bool InputHandler::keyReleased(const OIS::KeyEvent &e)
-  {
-    return true;
-  }
-
-  /**
-    @brief Event handler for the mouseMoved Event.
-    @param e Event information
-  */
-  bool InputHandler::mouseMoved(const OIS::MouseEvent &e)
-  {
-    return true;
-  }
-
-  /**
-    @brief Event handler for the mousePressed Event.
-    @param e Event information
-    @param id The ID of the mouse button
-  */
-  bool InputHandler::mousePressed(const OIS::MouseEvent &e, OIS::MouseButtonID id)
-  {
-    COUT(1) << "asdf" << std::endl;
-    return true;
-  }
-
-  /**
-    @brief Event handler for the mouseReleased Event.
-    @param e Event information
-    @param id The ID of the mouse button
-  */
-  bool InputHandler::mouseReleased(const OIS::MouseEvent &e, OIS::MouseButtonID id)
-  {
-    return true;
-  }
-
-}
Index: code/branches/input/src/orxonox/InputHandler.h
===================================================================
--- code/branches/input/src/orxonox/InputHandler.h	(revision 969)
+++ 	(revision )
@@ -1,108 +1,0 @@
-/*
- *   ORXONOX - the hottest 3D action shooter ever to exist
- *
- *
- *   License notice:
- *
- *   This program is free software; you can redistribute it and/or
- *   modify it under the terms of the GNU General Public License
- *   as published by the Free Software Foundation; either version 2
- *   of the License, or (at your option) any later version.
- *
- *   This program is distributed in the hope that it will be useful,
- *   but WITHOUT ANY WARRANTY; without even the implied warranty of
- *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *   GNU General Public License for more details.
- *
- *   You should have received a copy of the GNU General Public License
- *   along with this program; if not, write to the Free Software
- *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
- *
- *   Author:
- *      Reto Grieder
- *   Co-authors:
- *      ...
- *
- */
-
-/**
- @file
- @brief Implementation of a little Input handler that distributes everything
-        coming from OIS.
- */
-
-#ifndef _InputHandler_H__
-#define _InputHandler_H__
-
-#include <OIS/OIS.h>
-
-#include "OrxonoxPrereqs.h"
-#include "core/Tickable.h"
-#include "InputEvent.h"
-
-namespace orxonox
-{
-  /**
-    @brief Captures and distributes mouse and keyboard input.
-    It resolves the key bindings to InputEvents which can be heard by
-    implementing the InputEventListener interface.
-  */
-  class _OrxonoxExport InputHandler
-        : public Tickable, public OIS::KeyListener, public OIS::MouseListener
-  {
-    //friend class ClassIdentifier<InputHandler>;
-  public:
-    bool initialise(size_t windowHnd, int windowWidth, int windowHeight);
-    void destroyDevices();
-    void tick(float dt);
-    void setWindowExtents(int width, int height);
-
-    // Temporary solutions. Will be removed soon!
-    OIS::Mouse    *getMouse()    { return this->mouse_   ; }
-    OIS::Keyboard *getKeyboard() { return this->keyboard_; }
-
-    static InputHandler* getSingleton();
-    static void destroySingleton();
-
-  private:
-    // don't mess with a Singleton
-    InputHandler ();
-    InputHandler (const InputHandler&);
-    InputHandler& operator=(const InputHandler& instance);
-    ~InputHandler();
-
-    void callListeners(InputEvent &evt);
-
-    // input events
-		bool mousePressed (const OIS::MouseEvent &arg, OIS::MouseButtonID id);
-		bool mouseReleased(const OIS::MouseEvent &arg, OIS::MouseButtonID id);
-    bool mouseMoved   (const OIS::MouseEvent &arg);
-		bool keyPressed   (const OIS::KeyEvent   &arg);
-		bool keyReleased  (const OIS::KeyEvent   &arg);
-
-    OIS::InputManager *inputSystem_;    //!< OIS input manager
-    OIS::Keyboard     *keyboard_;       //!< OIS mouse
-    OIS::Mouse        *mouse_;          //!< OIS keyboard
-
-    /** denotes the maximum number of different keys there are in OIS.
-        256 should be ok since the highest number in the enum is 237. */
-    static const int numberOfKeys_ = 256;
-    //! Array of input events for every pressed key
-    InputEvent bindingsKeyPressed_[numberOfKeys_];
-    //! Array of input events for every released key
-    InputEvent bindingsKeyReleased_[numberOfKeys_];
-
-    /** denotes the maximum number of different buttons there are in OIS.
-        16 should be ok since the highest number in the enum is 7. */
-    static const int numberOfButtons_ = 16;
-    //! Array of input events for every pressed key
-    InputEvent bindingsButtonPressed_[numberOfButtons_];
-    //! Array of input events for every released key
-    InputEvent bindingsButtonReleased_[numberOfButtons_];
-
-    //! Pointer to the instance of the singleton
-    static InputHandler *singletonRef_s;
-  };
-}
-
-#endif /* _InputHandler_H__ */
Index: code/branches/input/src/orxonox/OrxonoxPlatform.h
===================================================================
--- code/branches/input/src/orxonox/OrxonoxPlatform.h	(revision 969)
+++ code/branches/input/src/orxonox/OrxonoxPlatform.h	(revision 971)
@@ -271,5 +271,5 @@
 
 // include visual leak detector to search for memory links
-// #include <vld.h>
+//#include <vld.h>
 
 #endif /* _OrxonoxPlatform_H__ */
Index: code/branches/input/src/orxonox/core/CMakeLists.txt
===================================================================
--- code/branches/input/src/orxonox/core/CMakeLists.txt	(revision 969)
+++ code/branches/input/src/orxonox/core/CMakeLists.txt	(revision 971)
@@ -5,4 +5,6 @@
   Identifier.cc
   IdentifierDistributor.cc
+  InputHandler.cc
+  InputManager.cc
   MetaObjectList.cc
   ConfigValueContainer.cc
Index: code/branches/input/src/orxonox/core/InputEvent.h
===================================================================
--- code/branches/input/src/orxonox/core/InputEvent.h	(revision 971)
+++ code/branches/input/src/orxonox/core/InputEvent.h	(revision 971)
@@ -0,0 +1,52 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Reto Grieder
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+ @file
+ @brief InputEvent Structure declaration
+ */
+
+#ifndef _InputEvent_H__
+#define _InputEvent_H__
+
+#include "CorePrereqs.h"
+
+namespace orxonox
+{
+  /**
+    @brief Interface that any class can use to get key independent input.
+  */
+  struct InputEvent
+  {
+    unsigned char id;      //!< Event ID
+    bool bStarted;         //!< Tells whether the Event started or ended (e.g. firing started)
+    int data1, data2;      //!< Two additional integer datafields, for instance for the mouse moved event
+    void* dataRef;         //!< Additional pointer to any further data
+  };
+}
+
+#endif /* _InputEvent_H__ */
Index: code/branches/input/src/orxonox/core/InputEventListener.cc
===================================================================
--- code/branches/input/src/orxonox/core/InputEventListener.cc	(revision 971)
+++ code/branches/input/src/orxonox/core/InputEventListener.cc	(revision 971)
@@ -0,0 +1,51 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Reto Grieder
+ *   Co-authors:
+ *      Some guy writing the example code from Ogre
+ *
+ */
+
+/**
+ @file
+ @brief Core relevant parts of InputEventListener
+ */
+
+#include "core/CoreIncludes.h"
+#include "InputEventListener.h"
+
+namespace orxonox
+{
+  /**
+    @brief standard constructor
+  */
+  InputEventListener::InputEventListener()
+  {
+    RegisterRootObject(InputEventListener);
+    this->bActive_ = true;
+  }
+
+  InputEventListener::~InputEventListener()
+  {
+  }
+
+}
Index: code/branches/input/src/orxonox/core/InputEventListener.h
===================================================================
--- code/branches/input/src/orxonox/core/InputEventListener.h	(revision 971)
+++ code/branches/input/src/orxonox/core/InputEventListener.h	(revision 971)
@@ -0,0 +1,60 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Reto Grieder
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+ @file
+ @brief InputEventListener Interface declaration
+ */
+
+#ifndef _InputEventListener_H__
+#define _InputEventListener_H__
+
+#include "CorePrereqs.h"
+
+#include "core/OrxonoxClass.h"
+#include "InputEvent.h"
+
+namespace orxonox
+{
+  /**
+    @brief Interface that any class can use to get key independent input.
+  */
+  class _CoreExport InputEventListener : virtual public OrxonoxClass
+  {
+    friend class InputHandler;
+  public:
+    InputEventListener();
+    virtual ~InputEventListener();
+    /** Method is called every time an Input event occurs && bActive */
+    virtual void eventOccured(InputEvent &evt) = 0;
+
+  private:
+    bool bActive_;
+  };
+}
+
+#endif /* _InputEventListener_H__ */
Index: code/branches/input/src/orxonox/core/InputHandler.cc
===================================================================
--- code/branches/input/src/orxonox/core/InputHandler.cc	(revision 971)
+++ code/branches/input/src/orxonox/core/InputHandler.cc	(revision 971)
@@ -0,0 +1,259 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Reto Grieder
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+ @file
+ @brief Implementation of a little Input handler that distributes everything
+        coming from OIS.
+ */
+
+#include "core/CoreIncludes.h"
+#include "core/Debug.h"
+#include "InputEventListener.h"
+#include "InputHandler.h"
+
+namespace orxonox
+{
+  /**
+    @brief The reference to the singleton
+  */
+  InputHandler* InputHandler::singletonRef_s = 0;
+
+  /**
+    @brief Constructor only resets the pointer values to 0.
+  */
+  InputHandler::InputHandler() :
+      mouse_(0), keyboard_(0), inputSystem_(0)
+  {
+  }
+
+  /**
+    @brief Destructor only called at the end of the program
+  */
+  InputHandler::~InputHandler()
+  {
+    this->destroyDevices();
+  }
+
+  /**
+    @brief The one instance of the InputHandler is stored in this function.
+    @return The pointer to the only instance of the InputHandler
+  */
+  InputHandler *InputHandler::getSingleton()
+  {
+    if (!singletonRef_s)
+      singletonRef_s = new InputHandler();
+    return singletonRef_s;
+  }
+
+  /**
+    @brief Creates the OIS::InputMananger, the keyboard and the mouse and
+           assigns the key bindings.
+    @param windowHnd The window handle of the render window
+    @param windowWidth The width of the render window
+    @param windowHeight The height of the render window
+  */
+  bool InputHandler::initialise(size_t windowHnd, int windowWidth, int windowHeight)
+  {
+    if (!this->inputSystem_)
+    {
+      // Setup basic variables
+      OIS::ParamList paramList;
+      std::ostringstream windowHndStr;
+
+      // Fill parameter list
+      windowHndStr << (unsigned int)windowHnd;
+      paramList.insert(std::make_pair(std::string("WINDOW"), windowHndStr.str()));
+
+#if defined OIS_LINUX_PLATFORM
+      paramList.insert(std::make_pair(std::string("XAutoRepeatOn"), std::string("true")));
+#endif
+
+      try
+      {
+        // Create inputsystem
+        inputSystem_ = OIS::InputManager::createInputSystem(paramList);
+        COUT(ORX_DEBUG) << "*** InputHandler: Created OIS input system" << std::endl;
+
+        // create a keyboard. If none are available the exception is caught.
+        keyboard_ = static_cast<OIS::Keyboard*>(inputSystem_->createInputObject(OIS::OISKeyboard, true));
+        keyboard_->setEventCallback(this);
+        COUT(ORX_DEBUG) << "*** InputHandler: Created OIS mouse" << std::endl;
+
+        // create a mouse. If none are available the exception is caught.
+        mouse_ = static_cast<OIS::Mouse*>(inputSystem_->createInputObject(OIS::OISMouse, true));
+        mouse_->setEventCallback(this);
+        COUT(ORX_DEBUG) << "*** InputHandler: Created OIS keyboard" << std::endl;
+
+        // Set mouse region
+        this->setWindowExtents(windowWidth, windowHeight);
+      }
+      catch (OIS::Exception ex)
+      {
+        // something went wrong with the initialisation
+        COUT(ORX_ERROR) << "Error: Failed creating an input system/keyboard/mouse. Message: \"" << ex.eText << "\"" << std::endl;
+        this->inputSystem_ = 0;
+        return false;
+      }
+    }
+
+    COUT(ORX_DEBUG) << "*** InputHandler: Loading key bindings..." << std::endl;
+    // load the key bindings
+    InputEvent empty = {0, false, 0, 0, 0};
+    for (int i = 0; i < this->numberOfKeys_; i++)
+      this->bindingsKeyPressed_[i] = empty;
+
+    //assign 'abort' to the escape key
+    this->bindingsKeyPressed_[(int)OIS::KC_ESCAPE].id = 1;
+    COUT(ORX_DEBUG) << "*** InputHandler: Loading done." << std::endl;
+
+    return true;
+  }
+
+  /**
+    @brief Destroys all the created input devices.
+  */
+  void InputHandler::destroyDevices()
+  {
+    COUT(ORX_DEBUG) << "*** InputHandler: Destroying InputHandler..." << std::endl;
+    if (this->mouse_)
+      this->inputSystem_->destroyInputObject(mouse_);
+    if (this->keyboard_)
+      this->inputSystem_->destroyInputObject(keyboard_);
+    if (this->inputSystem_)
+      OIS::InputManager::destroyInputSystem(this->inputSystem_);
+
+    this->mouse_         = 0;
+    this->keyboard_      = 0;
+    this->inputSystem_   = 0;
+    COUT(ORX_DEBUG) << "*** InputHandler: Destroying done." << std::endl;
+  }
+
+  /**
+    @brief Destroys the singleton.
+  */
+  void InputHandler::destroySingleton()
+  {
+    if (singletonRef_s)
+      delete singletonRef_s;
+    singletonRef_s = 0;
+  }
+
+  /**
+    @brief Updates the InputHandler
+    @param dt Delta time
+  */
+  void InputHandler::tick(float dt)
+  {
+    //this->mouse_->setEventCallback(this);
+    // capture all the input. That calls the event handlers.
+    if (mouse_)
+      mouse_->capture();
+
+    if (keyboard_)
+      keyboard_->capture();
+  }
+
+  /**
+    @brief Adjusts the mouse window metrics.
+    This method has to be called every time the size of the window changes.
+    @param width The new width of the render window
+    @param height the new height of the render window
+  */
+  void InputHandler::setWindowExtents(int width, int height)
+  {
+    // Set mouse region (if window resizes, we should alter this to reflect as well)
+    const OIS::MouseState &mouseState = mouse_->getMouseState();
+    mouseState.width  = width;
+    mouseState.height = height;
+  }
+
+  /**
+    @brief Calls all the objects from classes that derive from InputEventListener.
+    @param evt The input event that occured.
+  */
+  inline void InputHandler::callListeners(orxonox::InputEvent &evt)
+  {
+    for (Iterator<InputEventListener> it = ObjectList<InputEventListener>::start(); it; )
+    {
+      if (it->bActive_)
+        (it++)->eventOccured(evt);
+      else
+        it++;
+    }
+  }
+
+  /**
+    @brief Event handler for the keyPressed Event.
+    @param e Event information
+  */
+  bool InputHandler::keyPressed(const OIS::KeyEvent &e)
+  {
+    callListeners(this->bindingsKeyPressed_[(int)e.key]);
+    return true;
+  }
+
+  /**
+    @brief Event handler for the keyReleased Event.
+    @param e Event information
+  */
+  bool InputHandler::keyReleased(const OIS::KeyEvent &e)
+  {
+    return true;
+  }
+
+  /**
+    @brief Event handler for the mouseMoved Event.
+    @param e Event information
+  */
+  bool InputHandler::mouseMoved(const OIS::MouseEvent &e)
+  {
+    return true;
+  }
+
+  /**
+    @brief Event handler for the mousePressed Event.
+    @param e Event information
+    @param id The ID of the mouse button
+  */
+  bool InputHandler::mousePressed(const OIS::MouseEvent &e, OIS::MouseButtonID id)
+  {
+    COUT(1) << "asdf" << std::endl;
+    return true;
+  }
+
+  /**
+    @brief Event handler for the mouseReleased Event.
+    @param e Event information
+    @param id The ID of the mouse button
+  */
+  bool InputHandler::mouseReleased(const OIS::MouseEvent &e, OIS::MouseButtonID id)
+  {
+    return true;
+  }
+
+}
Index: code/branches/input/src/orxonox/core/InputHandler.h
===================================================================
--- code/branches/input/src/orxonox/core/InputHandler.h	(revision 971)
+++ code/branches/input/src/orxonox/core/InputHandler.h	(revision 971)
@@ -0,0 +1,120 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Reto Grieder
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+ @file
+ @brief Implementation of a little Input handler that distributes everything
+        coming from OIS.
+ */
+
+#ifndef _InputHandler_H__
+#define _InputHandler_H__
+
+#include <OIS/OIS.h>
+
+#include "CorePrereqs.h"
+#include "core/Tickable.h"
+#include "InputEvent.h"
+
+namespace orxonox
+{
+  /**
+    @brief Designates the way input is handled currently.
+    IM_GUI:      All the OIS input events are passed to CEGUI
+    IM_KEYBOARD: Only keyboard input is captured and passed to the InputBuffer
+    IM_INGAME:   Normal game mode. Key bindings and mouse are active.
+  */
+  enum InputMode
+  {
+    IM_GUI      = 0;
+    IM_KEYBOARD = 1;
+    IM_INGAME   = 2;
+  };
+
+  /**
+    @brief Captures and distributes mouse and keyboard input.
+    It resolves the key bindings to InputEvents which can be heard by
+    implementing the InputEventListener interface.
+  */
+  class _CoreExport InputHandler
+        : public Tickable, public OIS::KeyListener, public OIS::MouseListener
+  {
+  public:
+    bool initialise(size_t windowHnd, int windowWidth, int windowHeight);
+    void destroyDevices();
+    void tick(float dt);
+    void setWindowExtents(int width, int height);
+
+    // Temporary solutions. Will be removed soon!
+    OIS::Mouse    *getMouse()    { return this->mouse_   ; }
+    OIS::Keyboard *getKeyboard() { return this->keyboard_; }
+
+    static InputHandler* getSingleton();
+    static void destroySingleton();
+
+  private:
+    // don't mess with a Singleton
+    InputHandler ();
+    InputHandler (const InputHandler&);
+    InputHandler& operator=(const InputHandler& instance);
+    ~InputHandler();
+
+    void callListeners(InputEvent &evt);
+
+    // input events
+		bool mousePressed (const OIS::MouseEvent &arg, OIS::MouseButtonID id);
+		bool mouseReleased(const OIS::MouseEvent &arg, OIS::MouseButtonID id);
+    bool mouseMoved   (const OIS::MouseEvent &arg);
+		bool keyPressed   (const OIS::KeyEvent   &arg);
+		bool keyReleased  (const OIS::KeyEvent   &arg);
+
+    OIS::InputManager *inputSystem_;    //!< OIS input manager
+    OIS::Keyboard     *keyboard_;       //!< OIS mouse
+    OIS::Mouse        *mouse_;          //!< OIS keyboard
+
+    /** denotes the maximum number of different keys there are in OIS.
+        256 should be ok since the highest number in the enum is 237. */
+    static const int numberOfKeys_ = 256;
+    //! Array of input events for every pressed key
+    InputEvent bindingsKeyPressed_[numberOfKeys_];
+    //! Array of input events for every released key
+    InputEvent bindingsKeyReleased_[numberOfKeys_];
+
+    /** denotes the maximum number of different buttons there are in OIS.
+        16 should be ok since the highest number in the enum is 7. */
+    static const int numberOfButtons_ = 16;
+    //! Array of input events for every pressed key
+    InputEvent bindingsButtonPressed_[numberOfButtons_];
+    //! Array of input events for every released key
+    InputEvent bindingsButtonReleased_[numberOfButtons_];
+
+    //! Pointer to the instance of the singleton
+    static InputHandler *singletonRef_s;
+  };
+}
+
+#endif /* _InputHandler_H__ */
Index: code/branches/input/src/orxonox/core/InputHandlerBase.cc
===================================================================
--- code/branches/input/src/orxonox/core/InputHandlerBase.cc	(revision 971)
+++ code/branches/input/src/orxonox/core/InputHandlerBase.cc	(revision 971)
@@ -0,0 +1,41 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Reto Grieder
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+ @file
+ @brief Core relevant parts of InputEventListener
+ */
+
+#include "InputHandlerBase.h"
+
+namespace orxonox
+{
+  /**
+    @brief standard constructor
+  */
+
+}
Index: code/branches/input/src/orxonox/core/InputHandlerBase.h
===================================================================
--- code/branches/input/src/orxonox/core/InputHandlerBase.h	(revision 971)
+++ code/branches/input/src/orxonox/core/InputHandlerBase.h	(revision 971)
@@ -0,0 +1,48 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Reto Grieder
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+ @file
+ @brief InputHandlerBuffer class declaration
+ */
+
+#ifndef _InputHandlerBase_H__
+#define _InputHandlerBase_H__
+
+#include "CorePrereqs.h"
+
+namespace orxonox
+{
+  /**
+    @brief
+  */
+  class InputHandlerBase
+  {
+  };
+}
+
+#endif /* _InputHandlerBase_H__ */
